package de.ids_mannheim.korap.openthesaurus;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicLong;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import static de.ids_mannheim.korap.openthesaurus.OpenThesaurusData.getFile;
import static de.ids_mannheim.korap.openthesaurus.ThesaurusDictionary.createThesaurusDictionary;

@RestController
public class ResponseController {

    private final AtomicLong counter = new AtomicLong();
    String url = "https://www.openthesaurus.de/export/OpenThesaurus-Textversion.zip";
    String thesaurusFilepath = "downloads/openthesaurus.txt";
    InputStream thesaurusInputStream = ResponseController.class.getResourceAsStream("/static/openthesaurus.txt");
    Map<String, List<List<String>>> thesaurusDict = createThesaurusDictionary(thesaurusInputStream);

    @GetMapping("/openthesaurus")
    public Response openthesaurus(
            @RequestParam(value = "word", defaultValue = "") String word,
            @RequestParam(value = "update", defaultValue = "false") String update) {

        if (update.equals("true")) {
            try {
                getFile(url, this.thesaurusFilepath);
                thesaurusDict = createThesaurusDictionary(thesaurusFilepath);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        List<List<String>> synsetList = thesaurusDict.get(word);
        if (synsetList == null) {return new Response(counter.incrementAndGet(), new String[0][]);}
        String[][] synsetArrayAll = new String[synsetList.size()][];
        for (int i=0; i < synsetList.size(); i++) {
            List<String> synset = synsetList.get(i);
            String[] synsetArray = synset.toArray(new String[synset.size()]);
            synsetArrayAll[i] = synsetArray;
        }

        return new Response(counter.incrementAndGet(), synsetArrayAll);
    }
}
